/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: gmp_init.cc,v 1.13 2004/06/22 16:22:40 gawrilow Exp $"

#if defined(__GNUC__) && __GNUC_MINOR__<3 && !defined(__APPLE__) && !defined(__COMO__)
#pragma implementation
#endif

#include <memory>
#include "gmp_init.h"

#ifdef _POLYMAKE_LACKING_REALLOCATE
# define reallocate_fun pm::reallocate
#else
# define reallocate_fun pm::raw_alloc::reallocate
#endif

gmp_alloc_init::gmp_alloc_init() {
   static bool done=false;
   if (!done) {
      mp_set_memory_functions (pm::raw_alloc::allocate, reallocate_fun,
#ifdef __COMO__
			       (void (*)(void *, size_t))
#endif
			       pm::raw_alloc::deallocate);
      done=true;
   }
}
